#include<iostream.h>
#include<math.h>
#include "projet.h"            /* on inclut le fichier de dclaration des classes */

class Couleur;
class RGB;
class Image;
class point3d;
class vecteur3d;
class rayon;
class sphere;
class source;
class maillon;
class listesol;



int n=150;                     /* n correspond au nombre le lignes divis par 3  et de colonnes divis par 4 (format 4/3 de l'image)
                                     de l'image finale  on le place ici pour permettre  toutes les methodes d'y avoir acces  */





/*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                                  CLASSE COULEUR
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/


//                  CONSTRUCTEUR DE LA CLASSE COULEUR

Couleur :: Couleur (unsigned int rot, unsigned int grun, unsigned int blau)
{
  red=rot;
  green=grun;
  blue=blau;
};





            



/*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                                  CLASSE RGB
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/



//                  CONSTRUCTEUR DE LA CLASSE RGB 

RGB :: RGB ( double red, double green, double blue)
{
  r = red;
  g = green;
  b = blue;
};



//                  METHODE DE LA CLASSE RGB

//METHODES GET
double RGB::  getr(){
  return r;                     
};
double RGB::  getg(){
  return g;
};
double RGB::  getb(){
  return b;
};


//METHODE SOMME
RGB  somme(RGB a,RGB c){         /* cette mthode somme deux couleurs */
  RGB aux;                       /* on crer une couleur temporaire qui va etre retourne  la fin de la mthode */
  
  if( a.getr()+c.getr()<=1){     /* on affecte  la composante rouge de la couleur temporaire soit la somme des composantes rouges */
    aux.r=a.getr()+c.getr();     /* des deux couleurs a et c si cette somme est infrieure ou gale  1 ou si elle est suprieure */
  }                              /* on retourne 1 (saturation)*/
  else aux.r=1;
  
  if( a.getg()+c.getg()<=1){     /* on fait de mme avec les composantes verte et bleue */
    aux.g=a.getg()+c.getg();
  }
  else aux.g=1;
  
  if( a.getb()+c.getb()<=1){
    aux.b=a.getb()+c.getb();
  }
  else aux.b=1;
  
  return aux;                   /* on retourne la couleur temporaire en sortie , cette couleur tant la couleur somme des deux paramtres*/
};


//METHODE MUL
RGB  mul(double a,RGB b){                /* cette mthode multiplie l'intensit d'une couleur par un coefficient*/
  RGB aux;                               /* comme pour la mthode prcedente on crer une couleur temporaire */
 
  if((a*0.5*b.getr())<=1){               /*on multiplie les composantes vertes rouges et bleu de la lumire paramtre par le coefficient a*/
    aux.r=(a*0.5*b.getr());              /* on pondre cette multiplication par 1/2 pour viter une saturation trop rapide de chaque */
  }                                      /* composantes */
  else aux.r=1;
  
  if((b.getb()*0.5*a)<=1){
    aux.b=(a*0.5*b.getb());
  }
  else aux.b=1;
  
  if((a*0.5*b.getg())<=1){
   aux.g=(a*0.5*b.getg());
  }
  else aux.g=1; 
  
  return aux;   /* on retourne la couleur temporaire en sortie, cette couleur tant la couleur d'entre  multiplie  par la paramatre a */
};


//METHODE CONVERTIR
Couleur RGB :: convertir ()            /* cette methode convertit une couleur RGB en couleur Couleur */
{
  unsigned short r1,g1,b1;             /* on multiplie tout simplement chaque composante par 255 */
  r1= (unsigned short) floor(255*r);
  g1= (unsigned short) floor(255*g);
  b1= (unsigned short) floor(255*b);
  Couleur col (r1,g1,b1);
  return col;
};









/*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                                  CLASSE IMAGE
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/



//METHODES DE LA CLASSE IMAGE

Image :: Image ( int nbLignes, int nbColonnes){
  nbLig = nbLignes;
  nbCol = nbColonnes;
  pixel = new Couleur [nbCol * nbLig];
};


void Image :: save (char nomFichier [])
{
  ofstream outFile ;
  outFile.open(nomFichier, ios::out);
  outFile << "P3"<<endl;
  outFile <<"#"<< nomFichier << endl;
  outFile << nbCol << " "<< nbLig << endl;
  outFile << "255" <<endl;
  
  for (int i = 0; i < nbLig*nbCol ; i++)
    {
      outFile << pixel[i].getRed() << " "<< pixel[i].getGreen() << " "
              << pixel[i].getBlue() << " ";
      if ( (i+1) % 10 ==0)
        outFile << endl;
    }
  outFile.close();
};


void Image :: setCouleur (int i, int j, Couleur val)
{
  if ((i>=0)&&(i<nbLig)&&(j>=0)&&(j<nbCol))
    pixel[i*nbCol + j]=val;
};


Couleur Image :: getCouleur (int i, int j)
{
  return pixel[i*nbCol + j];
};








/*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                                  CLASSE POINT3d
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/



//                  CONSTRUCTEURS DE LA CLASSE POINT3d

point3d :: point3d() {};                                 /*constructeur vide*/

point3d :: point3d(double xx, double yy, double zz) {    /* creer un point de coordonnes x,y,z */
  x=xx;
  y=yy;
  z=zz;
};




//                  METHODES DE LA CLASSE POINT3d

//METHODE TRANSLATE
void point3d :: translate (vecteur3d v)        {
  x=x+v.x;                              /* translate le point par le vecteur v */
  y=y+v.y;                              /*on ajoute  chaque coordonns du point les coordonne correspondantes du vecteur paramtre */ 
  z=z+v.z;
};


//METHODE ECRIRE
void point3d :: ecrire(){
  cout<<"coordonees du point  (" <<x <<";" <<y <<" ; " <<z <<" )" <<endl;  /* affiche les coordonne du point ( x ;y ; z ) */
};


//METHODE DISTANCE
double  distance(point3d p1, point3d p2){
  vecteur3d aux;                        /* retourne la distance entre deux points p1 et p2 */
  aux = vecteur3d(p1,p2);               /*en fait, on calcule et retourne  la norme du vecteur form par ces 2 points*/
  return  (aux.norme());
};









/*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                            CLASSE VECTEUR3D
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/


//                  CONSTRUCTEURS DE LA CLASSE POINT3d

vecteur3d :: vecteur3d() {};

vecteur3d ::  vecteur3d(double xx, double yy, double zz){
  x=xx;
  y=yy;                                          /* creer un vecteur de coordonnees (x;y;z)   */
  z=zz;
};

vecteur3d ::  vecteur3d(point3d p1, point3d p2){
  x=p2.x-p1.x;
  y=p2.y-p1.y;                                  /* creer un vecteur avec les points p1 et p2 comme extremites (il pointe vers p2) */
  z=p2.z-p1.z;
};




//                  METHODES DE LA CLASSE POINT3d

//METHODE ECRIRE
void vecteur3d ::  ecrire(){
  cout<<"coordonnee du vecteur (" <<x <<" ; " <<y <<" ; " <<z <<" )" <<endl;    /* affiche les coordonnees du vecteur */
};


//METHODE NORME
double vecteur3d :: norme(){ 
  return (sqrt(((x*x)+(y*y)+(z*z))));               /* retourne la norme du vecteur */
};


//METHODE SOMME
vecteur3d somme(vecteur3d v1,vecteur3d v2){
  vecteur3d aux;            /* on cre un vecteur temporaire */
  aux.x=v1.x+v2.x;          /* dont les composantes sont la somme des composantes de deux vecteurs paramtres */
  aux.y=v1.y+v2.y;          
  aux.z=v1.z+v2.z;
  return aux;               /* on retourne ce vecteur */
};


//METHODE MUL
vecteur3d mul(double lambda ,vecteur3d v) {
  v.x=(lambda*(v.x));
  v.y=(lambda*(v.y));               /* multiplie les coordonnes du vecteur par lambda */
  v.z=(lambda*(v.z));
  return v;
};


//METHODE PRODSCAL
double prodscal(vecteur3d v1, vecteur3d v2){
  return (((v1.x)*(v2.x))+((v1.y)*(v2.y))+((v1.z)*(v2.z)));     /*retourne la valeur du produit scalaire des deux vecteurs paramtres */
};


//METHODE PROJECTION
vecteur3d  projection(vecteur3d v, vecteur3d n) {
  double produit;vecteur3d aux;          /* on cre un vecteur temporaire */
  produit=prodscal(v,n);                 /* on calcule la valeur du produit scalaire de v sur n */
  aux.x=v.x-(produit*n.x);               /* on enleve  v le vecteur v' dfint par la direction du vecteur  n et de norme */ 
  aux.y=v.y-(produit*n.y);               /* le produit scalaire des deux vecteurs */
  aux.z=v.z-(produit*n.z);
  return aux;                            /* on retourne le vecteur ainsi cre */
};








/*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                                  CLASSE RAYON
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/



//                  CONSTRUCTEURS DE LA CLASSE RAYON

rayon :: rayon(){};

rayon ::  rayon(point3d a,vecteur3d b){
    double aux;aux=b.norme();
    b=mul((1/aux),b);
    origine=a;            /* creer un rayon d'origine a et de direction b */
    direction=b;
  }  




//                  METHODES DE LA CLASSE RAYON


//METHODE ECRIRE
void rayon :: ecrire(){
  cout<<"rayon d'origine (" <<origine.x <<" ; " <<origine.y <<" ; " <<origine.z <<" )" <<endl;  /* affiche les coordonnes de l'origine du rayon */
cout<<"et de direction (" <<direction.x <<" ; " <<direction.y <<" ; " <<direction.z <<" )" <<endl;/* et les coordonnes de son vecteur directeur */
};


//METHODE RAYONORIGINE
point3d rayon :: rayorigine(){
  return origine;            /* retourne le point d'origine du rayon */
};

//METHODE RAYDIRECTION
vecteur3d rayon :: raydirection(){
  return direction;           /* retourne le vecteur direction du rayon */
};









/*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                                  CLASSE SPHERE
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/


//                  CONSTRUCTEURS DE LA CLASSE SPHERE

sphere ::  sphere(){};

sphere ::  sphere(point3d center,double radius,RGB  color) {
    centre=center;            
    r=radius;                   /* creer une sphere de rayon radius et de centre center et de couleur color  */
    couleur=color;
  };
  



//                  METHODE DE LA CLASSE SPHERE


//METHODE ECRIRE
void sphere :: ecrire(){
  cout<<"sphere de centre de coordones (" <<centre.x <<" ; " <<centre.y <<" ; " <<centre.z <<" )" <<" et de rayon " <<r <<endl;
};

//METHODE GETCOLOR
RGB sphere ::  getcolor(){
  return couleur;
};


//METHODE CALCULNORAMLE
vecteur3d sphere:: calculnormale(point3d a){         
  vecteur3d aux;             /* on cre un vecteur temporaire */
  aux=vecteur3d(centre,a);   /* se vecteur  a pour extremit le point a parametre et le centre de la sphere*/
  aux=mul((1/r),aux);        /* on norme le vecteur ainsi obtenue*/
  return aux;                /* on le retourne */
  
};


//METHODE INTERSECTION
point3d sphere :: intersection(rayon ray) {
  point3d a,b,b1,b2;

//on extrait les champs privs du rayon ray (origine et direction )
  vecteur3d u;
  double normeu;
  a=ray.rayorigine();
  u=ray.raydirection();

// on norme le vecteur u (vecteur direction)
  normeu=(1/(u.norme()));
  u=mul(normeu,u);

// RESOLUTION DE L'EQUATION D'INTERSECTION
  double delta,normeCA;
  vecteur3d CA;
  CA=vecteur3d(centre,a);
  normeCA=CA.norme();
  //CALCUL DU DELTA
  delta=((4*((prodscal(CA,u))*(prodscal(CA,u))))-(4*((normeCA*normeCA)-r*r)));
  //SOLUTIONS
  if(delta<0){
    b=point3d(-199,0,0);
  }
  if(delta>=0){
    double aux1,aux2,n1,n2;
    aux1=(((-2*(prodscal(CA,u)))+sqrt(delta))/2);
    aux2=(((-2*(prodscal(CA,u)))-sqrt(delta))/2);
    b1.x=(((u.x)*aux1)+a.x);
    b1.y=(((u.y)*aux1)+a.y);
    b1.z=(((u.z)*aux1)+a.z);   /* une fois que l'quation du second degr est resolu, on obtient 0,1 ou 2 points d'intersection*/
    b2.x=(((u.x)*aux2)+a.x);   /*selon le signe du delta */
    b2.y=(((u.y)*aux2)+a.y);
    b2.z=(((u.z)*aux2)+a.z);
    vecteur3d ab1,ab2;
    ab1=vecteur3d(a,b1);
    ab2=vecteur3d(a,b2);
    // on retourne le point d'intersection le plus proche   
    n1=ab1.norme();
    n2=ab2.norme();
       if(n1<n2){
	b=b1;
       }
       else {
       b=b2;
       }
  }
  return b;
};









/*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                                  CLASSE LISTESOL
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/



//                  CONSTRUCTEUR DE LA CLASSE LISTESOL

listesol :: listesol(){ 
  premier = NULL;
};




//                  METHODES  DE LA CLASSE LISTESOL


//METHODE AJOUTE0
void listesol :: ajoute0(){        /* cette mthode ajoute un maillon qui ne pointe sur aucune sphere, son but tant de permettre */
    maillon *aux; aux=new maillon; /* le parcours total de la liste de spheres avec la boucle employ ds la main : */
    aux->suiv=NULL;                /*   ( while((pm->suiv)!=NULL){............................pm=pm->suiv;} ) */
    premier=aux;                   /* sans cette mthode on ne peut pas atteindre le dernier maillon */
  }


//METHODE AJOUTE
void listesol :: ajoute(sphere sph) {         /* cette mthode ajoute la sphere sph  la liste de spheres */
  maillon * a;                                /* on cre un nouveau mailon*/
  a= new maillon;
  (a->ps)=sph;                                /* ce maillon contient la sphere parametre et pointe vers le premier maillon */
  (a->suiv)=premier;                          /* de la chaine tandis que le pointeur qui pointe le dbut de la chane pointe */
  premier=a;                                  /* le maillon ainsi cre. On a bien insrer le maillon cre en dbut de chane */
};


//METHODE SUIVANT ET FIRST
maillon * listesol::  suivant() {
  return premier->suiv;
};
maillon * listesol:: first(){
   return premier;
};
  

//METHODE RETOURNERAYON1                         /* cette mthode retourne le rayon qui passe par le point ou se situe "l'oeil" */
rayon  retournerayon1(int i, int j){             /* et le pixel de l'cran de coordones (f,g) */
  double step=(2.0/((3*n)-1));
  point3d pixel(0,(1-(i*step)),(1-(j*step)));    /* on calcul le coordonne du pixel ds le referentiel */
  point3d pdvue(-2,0,0);                             
  vecteur3d aux(pdvue,pixel);                    /* on calcule le vecteur qui part de l'oeil et qui va au pixel en question */
  rayon  ra;                                     /* on fabrique le rayon d'origine le pixel et de vecteur le vecteur ci dessus norm */
  ra=rayon(pixel,aux);                                
  return ra;                                     /* on retourne le rayon ainsi cre */
}







/*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                                  CLASSE SOURCE
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/




//                  CONSTRUCTEURS DE LA CLASSE SOURCE
source :: source(){};

source ::  source(point3d a,RGB b){
    origine=a;
    couleur=b;
}




//                  METHODES DE LA CLASSE SOURCE

//METHODE GETORIGINE
point3d source :: getorigine(){
    return origine;
}

//METHODE GETCOULEUR
RGB source :: getcouleur(){
    return couleur;
};


//METHODE RAYONP3DS
rayon source:: rayonp3ds(point3d a){    /*cette methode retourne le rayon passant par le point source lumineuse et */
  vecteur3d aux;                                                  /* le point a*/
  aux=vecteur3d(origine,a);
  rayon aux1;
  aux1=rayon(origine,aux);
  return aux1;
};
    

//METHODE TEST
int source:: test(point3d a,listesol c){   /* Cette mthode test si le point a est clair par la source ou cach */
  maillon *pm;                             /* par un esphere de la liste de sphere c*/
  pm=c.first();
  point3d inter(-199,0,0);                 /* on dfinit un point d'intersection par deafut */
  sphere * sol;                            /* on dfinit un pointeur sur une sphre */      
  rayon aux;
  aux=rayonp3ds(a);                        /* on determine le rayon passant par le point a et le point source lumineuse*/
  while(pm->suiv!=NULL){                   /* on parcours la liste de sphere*/
    point3d p(-199,0,0);                   /* on dfinit un point d'intersection variable par dfaut*/
    sol=&(pm->ps);                              
    p=sol->intersection(aux);              /*on calcul le point d'intersection de la sphere du maillon sur lequel on se trouve et du rayon */
    if(p.x!=-199 && inter.x!=-199){        /* si l'intersection par dfaut et l'intersection variable ont chang depuis le dbut */
      if(distance(origine,p)<distance(origine,inter)){ 
	inter=p;                           /* on mets le point d'intersection le plus proche comme intersection par defaut */
      }
    }
    else if(inter.x==-199 && p.x!=-199){  
      inter=p;               
    }
    pm=pm->suiv;;
  }
  if(distance(inter,a)>0.01){        /* si la distance entre le point d'intersection et le point paramtre est superieure  0.01 */
    return 1;                        /* (arrondissement dans le calcul de la norme) alors le point a est cach de la source par */
  }                                  /* un autre point . Donc on retourne 1 */
  else return 0;                     /* sinon on retourne 0 */
};






/*#############################################################################
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                               MAIN  
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
##############################################################################*/




void main(void){
/*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
	    	             CREATION DES SPHERES
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/
   

//On dfinit tout d'abord les 3 paramtres de chaque spheres avant d'apeler
//le constructeur sphere : -Le centre , -Le rayon , -La couleur
 
  // creation de la sphere1 
    point3d centre1(6,1,-1);
    RGB couleur1(0.3,0.15,0.7);
    double rayon1=0.5;
    sphere sphere1(centre1,rayon1,couleur1);
    cout<<"sphere 1  : ";
    sphere1.ecrire();
    
    //creation de la sphere2
    point3d centre2(9,-2,-1);
    RGB couleur2(0.11,0.41,0.11);
    double rayon2=2;
    sphere sphere2(centre2,rayon2,couleur2);
    cout<<"sphere 2  : ";
    sphere2.ecrire();

    //creation de la sphere3
    
    point3d centre3(20,4,3);
    RGB couleur3(0.2,0.2,0.3);
    double rayon3=3;
    sphere sphere3(centre3,rayon3,couleur3); 
    cout<<"sphere 3  : ";
    sphere3.ecrire();

    //cration de la sphere4
    
    point3d centre4(14,5,0);
    RGB  couleur4(0.8,0.3,0.1);
    double rayon4=0.6;
    sphere sphere4(centre4,rayon4,couleur4);
    cout<<"sphere 4  : ";
    sphere4.ecrire();




/*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                            CREATION DE LA LISTE DE SPHERE
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/

//On utilise la methode ajoute(sphere) pour placer les spheres dsires dans la liste.
//REMARQUE (rappel) la premire methode  apeler aprs le constructeur est la mthode ajoute0()
//qui a t crer afin de permettre de balayer toute la liste de sphere par la suite


    //creation de la liste de solide liste1
    listesol liste1;
    liste1.ajoute0(); 
    liste1.ajoute(sphere3);
    liste1.ajoute(sphere2);
    liste1.ajoute(sphere1);
    liste1.ajoute(sphere4);
 
 

/*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                          CREATION DE LA SOURCE LUMINEUSE
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/
   
    //creation de la source de lumiere source1
    point3d sp3d(0,8,-3);
    RGB sRGB(0.8,0.8,0.8);
    source  source1(sp3d,sRGB);


/*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                                    CALCUL DE L'IMAGE
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/


    //CREATION DE L'IMAGE
    Image scene2(3*n,4*n);
    int f,g;
    RGB couleur11(0.2,0.2,0.2);
    Couleur Cr = couleur1.convertir();
    point3d a(-2,0,0);
    
    rayon   raytest;
    sphere  solid;
    point3d  p;
    point3d  inter;
    sphere   s;
    maillon *pm;
    pm=new maillon;
    
    //CALCUL DE L'IMAGE          (on calcul ici une image en format 4/3 =>plus pratique pour fond d'cran, photos,etc....)
    for(f=1;f<(3*n);f++){       /* f correspond au numro de la ligne de l'image ou l'on se situe , la limite superieure tant 3*n*/
      for(g=1;g<(4*n);g++){     /*g correspond au numro de la colonne de l'image o l'on se situe , la limite supriere tant 4*n*/
	
	
	//METHODE POURCENTAGE
	double pourcentage=((f*100)/(3*n));double pourcentage1;if(f==1){pourcentage1=pourcentage;}
	if(pourcentage<100){      /* Cette mthode a pour but de donner un indice de l'tat d'avancement du calcul en % */
	  if(floor (pourcentage)==pourcentage1+1){
	    cout<<pourcentage <<"%" <<endl;
	  };
	  pourcentage1=floor (pourcentage);
	}
	
	
	//CALCUL DE L'IMAGE (SUITE)
	point3d inter(-199,0,0);         /* on dfinit un point inter initiale d'intersection par dfaut pour la ligne f ,colonne g*/
	point3d p(-199,0,0);             /* on dfinit un point p d'intersection variable */
	pm=liste1.first();               /*on crer un pointeur sur le premier maillon de la liste de spheres */
	
	
	while(pm->suiv!=NULL){                    /*on parcours la liste de sphere de maillon en maillon jusqu'a arriver sur le maillon 0 */ 
	  solid=pm->ps;                           /* on se place sur la sphere du maillon sur lequel on est */
	  raytest=retournerayon1(f,g);            /* on creer le rayon qui passe par le pixel de la ligne f et de la collonne g*/
	  p=solid.intersection(raytest);          /* on enregistre l'intersection de ce rayon avec la sphere */
	  
	  if(p.x!=-199 && inter.x!=-199){         /* si le rayon intercepte la sphere (au point p) et en a deja intercepter une (au point inter) */
	    if(distance(a,p)<distance(a,inter)){  /* on compare la distance des 2 points d'intersection et de l'cran que l'on a */
	      inter=p;                            /* si le point p est le lus proche de l'cran que inter ou remplace inter par p   */
	      s=solid;                            /* et on mets la sphere  laquelle appartient p comme sphere par defaut  */
	    }
	  }
	  else if(inter.x==-199 && p.x!=-199){    /* si il n'y a pas d'intersection antrieure, on mets p comme intersection par dfaut */
	    inter=p;                              /* et la sphere  laquelle appartient p comme sphere par defaut */
	    s=solid;
	  }
	  pm=pm->suiv;                            /* on recommence avec la sphere du maillon suivant */
	}
	
	



	if(inter.x==-199){                  /* si l'intersection par defaut est l'intersection initiale, le rayon n'a pas rencontrer de sphere */
	  Couleur Cf;double ee;ee=(f/(4));
	  couleur11=RGB(ee,ee,ee);          /* on convertit la couleur du fond de RGB en Couleur . Ici la couleur depends de la ligne sur */
	  Cf=couleur11.convertir();                       /*laquelle on se situe (f)  afin de creer un degrad de la couleur de fond */
	  scene2.setCouleur(f,g,Cf);                      /* le pixel decoordonnes (f,g) prends donc la couleur de fond */
	}
	else{                                             /* si l'intersection par defaut n'est pas l'interstion initiale, le rayon a rencont une sphere */
	  Couleur Cf;RGB Ct,Ca;
	  Ct=s.getcolor();
	  vecteur3d n;n=s.calculnormale(inter);                        /* on definit le vecteur normal  la sphere passant par le point d'intersection */
	  vecteur3d rss;rss=(source1.rayonp3ds(inter)).raydirection(); /*on dfinit le vecteur directeur du rayon partant de l'origine de la */
	  if((source1.test(inter,liste1))==0){                         /* source lumineuse  at allant vers le point d'intersection */
	    double pr;pr=prodscal(n,rss);                              /* on calcul le produit scalaire de ces deux vecteurs */                  
	    if(pr<0){pr=-pr;};
	    Ca=mul(pr,source1.getcouleur());                           /* l'apport lunineux de la source lumineuse est proportionnel  ce porduit scalaire */
	    Ct=somme(Ca,Ct);                                           /* la couleur du point considr est la somme de sa couleur d'origine plus   la */
	    Cf=Ct.convertir();                                         /* contribution de la source lumineuse */
	    scene2.setCouleur(f,g,Cf);                                 /*le pixel de coordonnes(f,g) prends donc la couleur ainsi calcule */ 
	  }
	  else if((source1.test(inter,liste1))==1){
	    Cf=Ct.convertir();
	    scene2.setCouleur(f,g,Cf);
	  }
	}
      }
    }
    
    
    
/*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                                         SAUVEGARDE DE L'IMAGE
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/

    cout<<"100%" <<endl;
    cout<<"ENREGISTREMENT DE L'IMAGE   patientez..."   <<endl;
    scene2.save("scene.ppm");                             /* on sauvegarde l'imafe dans le fichier scenne.ppm */

};
